#ifndef _ComboSystem
#define _ComboSystem

#include<string>
#include<vector>

using namespace std;

/// <summary>Է  ִ Ű ̸ ǥصӴϴ.</summary>
enum EnumKey
{
    UP,
    DOWN,
    FRONT,
    BACK,
    PUNCH,
    KICK
};

/// <summary>޺   Դϴ.</summary>
class TrieNode
{
public:
    /// <summary> 忡 Ҵ  ִٸ, ǥմϴ.</summary>
    string currentName = "";
private:
    /// <summary> 尡 Ű ִ ŰԴϴ.</summary>
    EnumKey currentKey;

    /// <summary>   Դϴ.</summary>
    TrieNode* parent = nullptr;
    /// <summary>    ƮԴϴ.</summary>
    vector<TrieNode*> childList;

public:
    /// <summary>Է Ű ؼ ο 带 ߰մϴ.</summary>
    TrieNode(EnumKey wantKey)
    {
        currentKey = wantKey;
    }

    /// <summary>  ߿ شϴ Ű  带 ãϴ.</summary>
    TrieNode* FindChild(EnumKey wantKey);

    /// <summary>شϴ Ű   带 ϴ.</summary>
    TrieNode* NewChild(EnumKey wantKey);

    /// <summary>شϴ 迭  ġϴ  带 ãϴ.</summary>
    TrieNode* Find(EnumKey* wantArray, int wantArrayLength, int index);

    /// <summary>شϴ 迭   ο  ϴ.</summary>
    void Insert(EnumKey* wantArray, int wantArrayLength, int index, string wantName);

    /// <summary>ش 带 մϴ.</summary>
    void Delete();

    /// <summary>ش 忡 ̾    մϴ.</summary>
    void Destroy()
    {
        // 鿡   û ϴ.
        for (int i = 0; i < childList.size(); ++i)
        {
            childList[i]->Destroy();
        };

        free(this);
    }

    /// <summary> 尡  ִ Ű ɴϴ.</summary>
    EnumKey GetKey()
    {
        return currentKey;
    }
};

/// <summary>޺ ϴ ŬԴϴ.</summary>
class ComboSystem
{
private:
    /// <summary>Ʈ Ʈ Դϴ.</summary>
    TrieNode* rootTrie;
    /// <summary> Է Ű Դϴ.</summary>
    TrieNode* lastChecked = nullptr;
    /// <summary> Ŭ ٷִ Ѱ ðԴϴ.</summary>
    float expiredTime = 0.0f;
    /// <summary>Է  ,     ð ٷ մϴ.</summary>
    float limitInputTime = 0.0f;

    /// <summary>  ð ؼ νϽ մϴ.</summary>
public:
    ComboSystem(float limitTime)
    {
        rootTrie = new TrieNode(EnumKey::UP);
        limitInputTime = limitTime;
    }

    ~ComboSystem()
    {
        rootTrie->Destroy();
    }

    /// <summary> Ű Է  ϴ ԼԴϴ.</summary>
    /// <param name="inputKey"> Է Ű ֽϴ.</param>
    /// <param name="inputTime"> Է ð ֽϴ.</param>
    string Input(EnumKey inputKey, float inputTime);

    /// <summary>Ѱ  ð ٽ մϴ.</summary>
    void SetTimeLimit(float wantTime)
    {
        limitInputTime = wantTime;
    }

    /// <summary>  ٷִ ð  մϴ.</summary>
    void SetExpireTime(float wantTime)
    {
        expiredTime = wantTime;
    }

    /// <summary>ش 迭  ° ų ֽϴ. ̹  ڸ ų ִٸ, մϴ.</summary>
    void Insert(EnumKey* wantArray, int wantArrayLength, string wantName);

    /// <summary>ش 迭   ų ִٸ, ش ų մϴ.</summary>
    void Delete(EnumKey* wantArray, int wantArrayLength);

    /// <summary>ش 迭   ų ִٸ,  ų ̸ ٲߴϴ.</summary>
    void ChangeName(EnumKey* wantArray, int wantArrayLength, string wantName);

private:
    /// <summary>ֻ  ߿ ϴ Ű  带 ãϴ.</summary>
    TrieNode* FindNodeStart(EnumKey wantKey);

    /// <summary>ش 迭    带 ãϴ.</summary>
    TrieNode* FindNodeEnd(EnumKey* wantArray, int wantArrayLength);
};

#endif